/[gentoo-x86]/eclass/elisp-common.eclass
Gentoo

Diff of /eclass/elisp-common.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.20 Revision 1.28
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.20 2007/04/29 12:59:39 ulm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.28 2007/09/22 20:25:30 ulm Exp $
4# 4#
5# Copyright 2007 Christian Faulhammer <opfer@gentoo.org> 5# Copyright 2007 Christian Faulhammer <opfer@gentoo.org>
6# Copyright 2002-2007 Matthew Kennedy <mkennedy@gentoo.org> 6# Copyright 2002-2004 Matthew Kennedy <mkennedy@gentoo.org>
7# Copyright 2004-2005 Mamoru Komachi <usata@gentoo.org>
7# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com> 8# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com>
8# Copyright 2007 Ulrich Mueller <ulm@gentoo.org> 9# Copyright 2007 Ulrich Mueller <ulm@gentoo.org>
9# 10#
10# This is not a real eclass, but it does provide Emacs-related installation 11# @ECLASS: elisp-common.eclass
11# utilities. 12# @MAINTAINER:
12# 13# Feel free to contact the Emacs team through emacs@gentoo.org if you have
13# USAGE: 14# problems, suggestions or questions.
15# @BLURB: Emacs-related installation utilities
16# @DESCRIPTION:
14# 17#
15# Usually you want to use this eclass for (optional) GNU Emacs support of 18# Usually you want to use this eclass for (optional) GNU Emacs support of
16# your package. This is NOT for XEmacs! 19# your package. This is NOT for XEmacs!
20#
17# Many of the steps here are sometimes done by the build system of your 21# Many of the steps here are sometimes done by the build system of your
18# package (especially compilation), so this is mainly for standalone elisp 22# package (especially compilation), so this is mainly for standalone elisp
19# files you gathered from somewhere else. 23# files you gathered from somewhere else.
24#
20# When relying on the emacs USE flag, you need to add 25# When relying on the emacs USE flag, you need to add
21# 26#
22# emacs? ( virtual/emacs ) 27# emacs? ( virtual/emacs )
23# 28#
24# to your DEPEND/RDEPEND line and use the functions provided here to bring 29# to your DEPEND/RDEPEND line and use the functions provided here to bring
25# the files to the correct locations. 30# the files to the correct locations.
26# 31#
32# .SS
27# src_compile() usage: 33# src_compile() usage:
28# --------------------
29# 34#
30# An elisp file is compiled by the elisp-compile() function defined here and 35# An elisp file is compiled by the elisp-compile() function defined here and
31# simply takes the source files as arguments. In the case of interdependent 36# simply takes the source files as arguments.
32# elisp files, you can use the elisp-comp() function which makes sure all
33# files are loadable.
34# 37#
35# elisp-compile *.el || die "elisp-compile failed!" 38# elisp-compile *.el || die "elisp-compile failed"
36# or 39#
40# In the case of interdependent elisp files, you can use the elisp-comp()
41# function which makes sure all files are loadable.
42#
37# elisp-comp *.el || die "elisp-comp failed!" 43# elisp-comp *.el || die "elisp-comp failed"
38# 44#
39# Function elisp-make-autoload-file() can be used to generate a file with 45# Function elisp-make-autoload-file() can be used to generate a file with
40# autoload definitions for the lisp functions. It takes the output file name 46# autoload definitions for the lisp functions. It takes the output file name
41# (default: "${PN}-autoloads.el") and a list of directories (default: working 47# (default: "${PN}-autoloads.el") and a list of directories (default: working
42# directory) as its arguments. Use of this function requires that the elisp 48# directory) as its arguments. Use of this function requires that the elisp
43# source files contain magic ";;;###autoload" comments. See the Emacs Lisp 49# source files contain magic ";;;###autoload" comments. See the Emacs Lisp
44# Reference Manual (node "Autoload") for a detailed explanation. 50# Reference Manual (node "Autoload") for a detailed explanation.
45# 51#
52# .SS
46# src_install() usage: 53# src_install() usage:
47# --------------------
48# 54#
49# The resulting compiled files (.elc) should be put in a subdirectory of 55# The resulting compiled files (.elc) should be put in a subdirectory of
50# /usr/share/emacs/site-lisp/ which is named after the first argument 56# /usr/share/emacs/site-lisp/ which is named after the first argument
51# of elisp-install(). The following parameters are the files to be put in 57# of elisp-install(). The following parameters are the files to be put in
52# that directory. Usually the subdirectory should be ${PN}, you can choose 58# that directory. Usually the subdirectory should be ${PN}, you can choose
53# something else, but remember to tell elisp-site-file-install() (see below) 59# something else, but remember to tell elisp-site-file-install() (see below)
54# the change, as it defaults to ${PN}. 60# the change, as it defaults to ${PN}.
55# 61#
56# elisp-install ${PN} *.elc *.el || die "elisp-install failed!" 62# elisp-install ${PN} *.el *.elc || die "elisp-install failed"
57# 63#
58# To let the Emacs support be activated by Emacs on startup, you need 64# To let the Emacs support be activated by Emacs on startup, you need
59# to provide a site file (shipped in ${FILESDIR}) which contains the startup 65# to provide a site file (shipped in ${FILESDIR}) which contains the startup
60# code (have a look in the documentation of your software). Normally this 66# code (have a look in the documentation of your software). Normally this
61# would look like this: 67# would look like this:
62# 68#
63# ;;; csv-mode site-lisp configuration 69# ;;; csv-mode site-lisp configuration
64# 70#
65# (add-to-list 'load-path "@SITELISP@") 71# (add-to-list 'load-path "@SITELISP@")
66# (add-to-list 'auto-mode-alist '("\\.csv\\'" . csv-mode)) 72# (add-to-list 'auto-mode-alist '("\\.csv\\'" . csv-mode))
67# (autoload 'csv-mode "csv-mode" "Major mode for editing csv files." t) 73# (autoload 'csv-mode "csv-mode" "Major mode for csv files." t)
68# 74#
69# If your Emacs support files are installed in a subdirectory of 75# If your Emacs support files are installed in a subdirectory of
70# /usr/share/emacs/site-lisp/ (which is recommended if more than one file is 76# /usr/share/emacs/site-lisp/ (which is recommended if more than one file is
71# installed), you need to extend Emacs' load-path as shown in the first 77# installed), you need to extend Emacs' load-path as shown in the first
72# non-comment. The elisp-site-file-install() function of this eclass will 78# non-comment. The elisp-site-file-install() function of this eclass will
73# replace "@SITELISP@" by the actual path. 79# replace "@SITELISP@" by the actual path.
80#
74# The next line tells Emacs to load the mode opening a file ending with 81# The next line tells Emacs to load the mode opening a file ending with
75# ".csv" and load functions depending on the context and needed features. 82# ".csv" and load functions depending on the context and needed features.
76# Be careful though. Commands as "load-library" or "require" bloat the 83# Be careful though. Commands as "load-library" or "require" bloat the
77# editor as they are loaded on every startup. When having a lot of Emacs 84# editor as they are loaded on every startup. When having a lot of Emacs
78# support files, users may be annoyed by the start-up time. Also avoid 85# support files, users may be annoyed by the start-up time. Also avoid
79# keybindings as they might interfere with the user's settings. Give a hint 86# keybindings as they might interfere with the user's settings. Give a hint
80# in pkg_postinst(), which should be enough. 87# in pkg_postinst(), which should be enough.
88#
81# The naming scheme for this site file is "[0-9][0-9]*-gentoo.el", where the 89# The naming scheme for this site file is "[0-9][0-9]*-gentoo.el", where the
82# two digits at the beginning define the loading order. So if you depend on 90# two digits at the beginning define the loading order. So if you depend on
83# another Emacs package, your site file's number must be higher! 91# another Emacs package, your site file's number must be higher!
92#
84# Best practice is to define a SITEFILE variable in the global scope of your 93# Best practice is to define a SITEFILE variable in the global scope of your
85# ebuild (right after DEPEND e.g.): 94# ebuild (right after DEPEND e.g.):
86# 95#
87# SITEFILE=50${PN}-gentoo.el 96# SITEFILE=50${PN}-gentoo.el
88# 97#
89# Which is then installed by 98# Which is then installed by
90# 99#
91# elisp-site-file-install "${FILESDIR}/${SITEFILE}" 100# elisp-site-file-install "${FILESDIR}/${SITEFILE}"
92# 101#
93# in src_install(). If your subdirectory is not named ${PN}, give the 102# in src_install(). If your subdirectory is not named ${PN}, give the
94# differing name as second argument. 103# differing name as second argument.
95# 104#
105# .SS
96# pkg_postinst() / pkg_postrm() usage: 106# pkg_postinst() / pkg_postrm() usage:
97# ------------------------------------
98# 107#
99# After that you need to recreate the start-up file of Emacs after emerging 108# After that you need to recreate the start-up file of Emacs after emerging
100# and unmerging by using 109# and unmerging by using
101# 110#
102# pkg_postinst() { 111# pkg_postinst() {
103# elisp-site-regen 112# elisp-site-regen
104# } 113# }
114#
105# pkg_postrm() { 115# pkg_postrm() {
106# elisp-site-regen 116# elisp-site-regen
107# } 117# }
108# 118#
109# As always: Feel free to contact Emacs team through emacs@gentoo.org if you 119# When having optional Emacs support, you should prepend "use emacs &&" to
110# have problems, suggestions or questions. 120# above calls of elisp-site-regen(). Don't use "has_version virtual/emacs"!
121# When unmerging the state of the emacs USE flag is taken from the package
122# database and not from the environment, so it is no problem when you unset
123# USE=emacs between merge and unmerge of a package.
124#
125# .SS
126# Miscellaneous functions:
127#
128# elisp-emacs-version() outputs the version of the currently active Emacs.
111 129
112SITELISP=/usr/share/emacs/site-lisp 130SITELISP=/usr/share/emacs/site-lisp
131SITEFILE=50${PN}-gentoo.el
132EMACS=/usr/bin/emacs
133# The following works for Emacs versions 18-23, don't change it.
134EMACS_BATCH_CLEAN="${EMACS} -batch -q --no-site-file"
135
136# @FUNCTION: elisp-compile
137# @USAGE: <list of elisp files>
138# @DESCRIPTION:
139# Byte-compile Emacs Lisp files.
113 140
114elisp-compile() { 141elisp-compile() {
115 /usr/bin/emacs --batch -f batch-byte-compile --no-site-file --no-init-file $* 142 einfo "Compiling GNU Emacs Elisp files ..."
143 ${EMACS_BATCH_CLEAN} -f batch-byte-compile "$@"
116} 144}
145
146# @FUNCTION: elisp-emacs-version
147# @DESCRIPTION:
148# Output version of currently active Emacs.
149
150elisp-emacs-version() {
151 # The following will work for at least versions 18-23.
152 echo "(princ emacs-version)" >"${T}"/emacs-version.el
153 ${EMACS_BATCH_CLEAN} -l "${T}"/emacs-version.el
154}
155
156# @FUNCTION: elisp-make-autoload-file
157# @USAGE: [output file] [list of directories]
158# @DESCRIPTION:
159# Generate a file with autoload definitions for the lisp functions.
117 160
118elisp-make-autoload-file () { 161elisp-make-autoload-file () {
119 local f="${1:-${PN}-autoloads.el}" 162 local f="${1:-${PN}-autoloads.el}"
120 shift 163 shift
121 echo >"${f}" 164 einfo "Generating autoload file for GNU Emacs ..."
122 emacs --batch -q --no-site-file \ 165
166 sed 's/^FF/\f/' >"${f}" <<-EOF
167 ;;; ${f##*/} --- autoloads for ${P}
168
169 ;;; Commentary:
170 ;; Automatically generated by elisp-common.eclass
171 ;; DO NOT EDIT THIS FILE
172
173 ;;; Code:
174 FF
175 ;; Local Variables:
176 ;; version-control: never
177 ;; no-byte-compile: t
178 ;; no-update-autoloads: t
179 ;; End:
180 ;;; ${f##*/} ends here
181 EOF
182
183 ${EMACS_BATCH_CLEAN} \
123 --eval "(setq make-backup-files nil)" \ 184 --eval "(setq make-backup-files nil)" \
124 --eval "(setq generated-autoload-file (expand-file-name \"${f}\"))" \ 185 --eval "(setq generated-autoload-file (expand-file-name \"${f}\"))" \
125 -f batch-update-autoloads "${@-.}" 186 -f batch-update-autoloads "${@-.}"
126} 187}
127 188
189# @FUNCTION: elisp-install
190# @USAGE: <subdirectory> <list of files>
191# @DESCRIPTION:
192# Install files in SITELISP directory.
193
128elisp-install() { 194elisp-install() {
129 local subdir=$1 195 local subdir="$1"
130 dodir "${SITELISP}/${subdir}"
131 insinto "${SITELISP}/${subdir}"
132 shift 196 shift
197 einfo "Installing Elisp files for GNU Emacs support ..."
198 ( # subshell to avoid pollution of calling environment
199 insinto "${SITELISP}/${subdir}"
133 doins $@ 200 doins "$@"
201 )
134} 202}
203
204# @FUNCTION: elisp-site-file-install
205# @USAGE: <site-init file> [subdirectory]
206# @DESCRIPTION:
207# Install Emacs site-init file in SITELISP directory.
135 208
136elisp-site-file-install() { 209elisp-site-file-install() {
137 local sitefile=$1 my_pn=${2:-${PN}} 210 local sf="$1" my_pn="${2:-${PN}}"
138 pushd "${S}" 211 einfo "Installing site initialisation file for GNU Emacs ..."
139 cp ${sitefile} "${T}" 212 cp "${sf}" "${T}"
140 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" "${T}/$(basename ${sitefile})" 213 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" "${T}/$(basename "${sf}")"
214 ( # subshell to avoid pollution of calling environment
141 insinto ${SITELISP} 215 insinto "${SITELISP}"
142 doins "${T}/$(basename ${sitefile})" || die "failed to install site file" 216 doins "${T}/$(basename "${sf}")"
143 popd 217 )
144} 218}
219
220# @FUNCTION: elisp-site-regen
221# @DESCRIPTION:
222# Regenerate site-gentoo.el file.
145 223
146elisp-site-regen() { 224elisp-site-regen() {
225 local sflist sf line
226
147 einfo "Regenerating ${SITELISP}/site-gentoo.el ..." 227 einfon "Regenerating ${SITELISP}/site-gentoo.el ..."
148 einfo ""
149 cat <<EOF >${ROOT}${SITELISP}/site-gentoo.el 228 cat <<-EOF >"${T}"/site-gentoo.el
150;;; DO NOT EDIT THIS FILE -- IT IS GENERATED AUTOMATICALLY BY PORTAGE 229 ;;; site-gentoo.el --- site initialisation for Gentoo-installed packages
151;;; -----------------------------------------------------------------
152 230
231 ;;; Commentary:
232 ;; Automatically generated by elisp-common.eclass
233 ;; DO NOT EDIT THIS FILE
234
235 ;;; Code:
153EOF 236 EOF
237
154 for sf in ${ROOT}${SITELISP}/[0-9][0-9]*-gentoo.el 238 for sf in "${ROOT}${SITELISP}"/[0-9][0-9]*-gentoo.el
155 do 239 do
156 [ -r "${sf}" ] || continue 240 [ -r "${sf}" ] || continue
157 einfo " Adding $(basename ${sf}) ..." 241 sflist="${sflist} $(basename "${sf}")"
158 cat "${sf}" >>${ROOT}${SITELISP}/site-gentoo.el 242 cat "${sf}" >>"${T}"/site-gentoo.el
159 done 243 done
244
245 cat <<-EOF >>"${T}"/site-gentoo.el
246
247 (provide 'site-gentoo)
248
249 ;; Local Variables:
250 ;; no-byte-compile: t
251 ;; End:
252 ;;; site-gentoo.el ends here
253 EOF
254
255 if cmp -s "${ROOT}${SITELISP}"/site-gentoo.el "${T}"/site-gentoo.el; then
256 # This prevents outputting unnecessary text when there
257 # was actually no change
258 # A case is a remerge where we have doubled output
259 echo " no changes."
260 else
261 mv "${T}"/site-gentoo.el "${ROOT}${SITELISP}"/site-gentoo.el
262 echo; einfo
263 for sf in ${sflist}; do
264 einfo " Adding ${sf} ..."
265 done
160 while read line; do einfo "${line}"; done <<EOF 266 while read line; do einfo "${line}"; done <<EOF
161 267
162All site initialization for Gentoo-installed packages is now added to 268All site initialisation for Gentoo-installed packages is added to
163/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer 269/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer
164managed by Gentoo. You are responsible for all maintenance of 270managed by Gentoo. You are responsible for all maintenance of
165site-start.el if there is such a file. 271site-start.el if there is such a file.
166 272
167In order for this site initialization to be loaded for all users 273In order for this site initialisation to be loaded for all users
168automatically, as was done previously, you can add a line like this: 274automatically, you can add a line like this:
169 275
170 (load "/usr/share/emacs/site-lisp/site-gentoo" nil t) 276 (load "/usr/share/emacs/site-lisp/site-gentoo" nil t)
171 277
172to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line 278to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line
173can be added by individual users to their initialization files, or for 279can be added by individual users to their initialisation files, or for
174greater flexibility, users can select which of the package-specific 280greater flexibility, users can select which of the package-specific
175initialization files in /usr/share/emacs/site-lisp to load. 281initialisation files in /usr/share/emacs/site-lisp/ to load.
176EOF 282EOF
177 echo 283 echo
284 fi
178} 285}
179 286
180# The following Emacs Lisp compilation routine is taken from GNU 287# @FUNCTION: elisp-comp
181# autotools. 288# @USAGE: <list of elisp files>
289# @DESCRIPTION:
290# Byte-compile interdependent Emacs Lisp files.
291#
292# This function byte-compiles all ".el" files which are part of its
293# arguments, using GNU Emacs, and puts the resulting ".elc" files into the
294# current directory, so disregarding the original directories used in ".el"
295# arguments.
296#
297# This function manages in such a way that all Emacs Lisp files to be
298# compiled are made visible between themselves, in the event they require or
299# load one another.
182 300
183elisp-comp() { 301elisp-comp() {
184# Copyright 1995 Free Software Foundation, Inc. 302 # Copyright 1995 Free Software Foundation, Inc.
185# Fran├žois Pinard <pinard@iro.umontreal.ca>, 1995. 303 # Fran├žois Pinard <pinard@iro.umontreal.ca>, 1995.
186# This script byte-compiles all `.el' files which are part of its 304 # Originally taken from GNU autotools.
187# arguments, using GNU Emacs, and put the resulting `.elc' files into
188# the current directory, so disregarding the original directories used
189# in `.el' arguments.
190#
191# This script manages in such a way that all Emacs LISP files to
192# be compiled are made visible between themselves, in the event
193# they require or load-library one another.
194 305
195 if test $# = 0; then 306 test $# -gt 0 || return 1
196 exit 1 307
197 else
198 if test -z "${EMACS}" || test "${EMACS}" = "t"; then 308 if test -z "${EMACS}" || test "${EMACS}" = "t"; then
199 # Value of "t" means we are running in a shell under Emacs. 309 # Value of "t" means we are running in a shell under Emacs.
200 # Just assume Emacs is called "emacs". 310 # Just assume Emacs is called "emacs".
201 EMACS=emacs 311 EMACS=/usr/bin/emacs
202 fi
203
204 tempdir=elc.$$
205 mkdir ${tempdir}
206 cp $* ${tempdir}
207 cd ${tempdir}
208
209 echo "(add-to-list 'load-path \"../\")" > script
210 ${EMACS} -batch -q --no-site-file --no-init-file -l script -f batch-byte-compile *.el
211 mv *.elc ..
212
213 cd ..
214 rm -fr ${tempdir}
215 fi 312 fi
313 einfo "Compiling GNU Emacs Elisp files ..."
314
315 tempdir=elc.$$
316 mkdir ${tempdir}
317 cp "$@" ${tempdir}
318 pushd ${tempdir}
319
320 echo "(add-to-list 'load-path \"../\")" > script
321 ${EMACS_BATCH_CLEAN} -l script -f batch-byte-compile *.el
322 local ret=$?
323 mv *.elc ..
324
325 popd
326 rm -fr ${tempdir}
327 return ${ret}
216} 328}

Legend:
Removed from v.1.20  
changed lines
  Added in v.1.28

  ViewVC Help
Powered by ViewVC 1.1.20